



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Scalable IO in Java【java高效IO】</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Scalable IO in Java【java高效IO】</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 20:43:55 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><!--<br />
p.p1 {margin: 0.0px 0.0px 0.0px 0.0px; font: 32.0px Helvetica}<br />
p.p2 {margin: 0.0px 0.0px 0.0px 0.0px; font: 28.0px Helvetica}<br />
span.s1 {font: 14.5px Helvetica}<br />
--></p>
<p>第一次翻译，如有错误，请指正</p>
<p>1、Outline 大纲<br />Scalable network services&nbsp; 高效网络服务</p>
<p>Event-driven processing&nbsp; 事件驱动处理</p>
<p>Reactor pattern&nbsp; Reactor模式<br /> Basic version&nbsp; 基本版本<br /> Multithreaded versions&nbsp; 多线程版本<br /> Other variants&nbsp; 其他变体</p>
<p>2、Network Services  网络服务<br />Web services, Distributed Objects, etcMost have same basic structure。web服务，分布式对象，等等,&nbsp;大多是相同的基础结构<br />Read request 读请求<br /> Decode request 解码请求<br /> Process service 服务处理<br /> Encode reply 加密回复<br /> Send reply。发送响应<br />But differ in nature and cost of each step XML parsing, File transfer, Web page generation, computational services, ...<br />但是不同的是每一步的XML解析，文件传输、web网页生成，服务计算</p>
<p>3、Classic Service Designs&nbsp; 经典的服务设计</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/805549/201903/805549-20190330235754118-229493007.png" /></p>
<p>Each handler may be started in its own thread&nbsp; 每一个handler在自己的线程中启动</p>
<p>4、classic ServerSocket Loop 经典的ServerSocket循环</p>
<div>
<pre class="prettyprint linenums">public class Server implements Runnable{<br />
    @Override<br />
    public void run() {<br />
        try {<br />
            ServerSocket serverSocket = new ServerSocket(123456);<br />
            while (!Thread.interrupted()){<br />
                new Thread(new Handler(serverSocket.accept())).start();<br />
            }<br />
        } catch (IOException e) {<br />
            e.printStackTrace();<br />
        }<br />
    }

    static class Handler implements Runnable{<br />
        final Socket socket;

        public Handler(Socket socket) {<br />
            this.socket = socket;<br />
        }

        @Override<br />
        public void run() {<br />
            try {<br />
                byte[] input = new byte[];<br />
                socket.getInputStream().read(input);

                byte[] output = process(input);<br />
                socket.getOutputStream().write(output);<br />
            } catch (IOException e) {<br />
                e.printStackTrace();<br />
            }

        }

        private byte[] process(byte[] input) {<br />
            return null;<br />
        }<br />
    }<br />
}</pre>
</div>
<p>5、Scalability Goals 可伸缩目标</p>
<p>Graceful degradation under increasing load (more clients)<br />负载下（更多客户端）的优雅降级</p>
<p>Continuous improvement with increasing resources (CPU, memory, disk, bandwidth)<br />随着资源（CPU、内存、硬盘、带宽）的增加而不断改进</p>
<p>Also meet availability and performance goals Short latencies Meeting peak demand Tunable quality of service<br />可协调服务同时满足高峰需求的可用性和短延时的性能目标</p>
<p>Divide-and-conquer is usually the best approach for achieving any scalability goal<br />分而治之通常是实现任何可伸缩性目标最好的方法</p>
<p>6、Divide and Conquer 分而治之</p>
<p>Divide processing into small tasks 拆分小任务处理<br />Each task performs an action without blocking 每个任务执行无阻塞的执行一个动作</p>
<p>Execute each task when it is enabled  当执行每一个任务时，<br />an IO event usually serves as trigger IO事件通常用作触发器</p>
<p>Basic mechanisms supported in java.nio java.nio支持的基本机制<br />Non-blocking reads and writes  非阻塞读写<br />Dispatch tasks associated with sensed IO events 调度与感知IO事件相关的任务</p>
<p>Endless variation possible  无尽的变化<br />A family of event-driven designs  一系列事件驱动设计</p>
<p>degradation&nbsp; 退化</p>
<p>latency 潜在的</p>
<p>tunable 可调协的</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390v5w38.html">linux安装Jenkins</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zk13d8.html">聊聊JVM的年轻代</a>
		</li>
						<li><a href="https://www.batexi.com/a/m9660o49.html">java数据类型定义与输出</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1g7on9.html">MVC设计模式下实现数据库的连接，并获取所有数据到浏览器页面上显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn5j308.html">Android：数据存储之SQLite</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wew1xq.html">三种纯CSS实现三角形的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v5eym8.html">Index of super-prime - SGU 116（素数&plus;背包）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okmdme9.html">ASP&period;net  button类控件click事件中传递参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gev1yz8.html">&lpar;NO&period;00003&rpar;iOS游戏简单的机器人投射游戏成形记&lpar;九&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjvrk59.html">尚未备份数据库 &amp;quot&semi;&ast;&ast;&ast;&amp;quot&semi; 的日志尾部。如果该日志包含您不希望丢失的工作，请使用 BACKUP LOG WITH NORECOVERY 备份该日志。</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjrlwz9.html">【xsy1503】 fountain DP</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gn2vvq.html">DataStream&lowbar;操作基本类型数据的流对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4nnnm9.html">13&period;Mysql触发器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emylmz9.html">Android -- startActivityForResult和setResult</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pmwx3y9.html">linux多线程同步</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwovg0y9.html">python 数据结构应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwo5jwz9.html">【LabVIEW技巧】LabVIEW中的错误2</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlokmzeq.html">ORACLE的测试用户Scott</a>
		</li>
						<li><a href="https://www.batexi.com/a/q15lr149.html">win7下docker配置加速器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r47wle8.html">C&num;获取视频文件播放长度</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2ky20xq.html">SQL Server 的通用分页显示存储过程（转载）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kor24rq.html">Git 个人笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/963zdn39.html">大学生Linux常用命令（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9537z108.html">关于Netty的学习前总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/902kkpnq.html">人工智能AI芯片与Maker创意接轨 （中）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rnkwz4q.html">通过python将xml文件转换成html文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pp2v349.html">Docker配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/902klp4q.html">如何配置php客户端（phpredis）并连接Redis--华为DCS for Redis使用经验系列</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1p70k9.html">day12生成器</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7e0wle9.html">Hyperledger Fabric&lpar;v1&period;1&period;0&rpar;编译时遇到的问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
